<template>
    <div>
        <video ref="video" class="video" :media-stream.camel="mediaStream" :muted="muted" autoplay playsinline></video>
        <statistics :statistics="conference.statistics" :visible="statisticsVisible"/>
        <div class="controls">
            <button class="button speaker" :class="{ on: !muted }" @click="muted = !muted "/>
        </div>
    </div>
</template>

<script setup>

    import { ref, computed, onMounted, onBeforeUnmount } from "vue";
    import Statistics from "./Statistics.vue";

    const props = defineProps({
        conference: Object,
        statisticsVisible: Boolean,
    });

    const video = ref(null);

    const mediaStream = computed(() => {
        return props.conference.mediaStream;
    });

    let muted = ref(true);

    let resizeObserver = null;

    onMounted(() => {
        let AudioContext = window.AudioContext || window.webkitAudioContext || Object;
        let audioContext = new AudioContext();
        audioContext.onstatechange = () => {
            if (audioContext.state === "running") {
                muted.value = false;
                audioContext.close();
            }
        }
        resizeObserver = new ResizeObserver((entries) => {
            let width = entries[0].contentRect.width;
            let height = entries[0].contentRect.height;
            let frameArea = Number.POSITIVE_INFINITY;
            if (width < 1280 && height < 720) {
                frameArea = 640 * 360;
            }
            if (width < 640 && height < 360) {
                frameArea = 320 * 180;
            }
            if (video.value.mediaStream != null) {
                video.value.mediaStream.setMaxVideoFrameArea(frameArea);
            }
        });
        resizeObserver.observe(video.value);
    });

    onBeforeUnmount(() => {
        if (resizeObserver != null) {
            resizeObserver.unobserve(video.value);
            resizeObserver = null;
        }
        video.value.mediaStream = null;
    });

</script>

<style scoped>

    .video {
        width: 100%;
        height: 100%;
        object-fit: cover;
    }

    .controls {
        position: absolute;
        bottom: 5px;
        left: 5px;
        padding: 5px 10px;
        font-size: 1em;
        background: #212121;
        display: flex;
        flex-direction: row;
        align-items: center;
    }

    .button {
        display: flex;
        width: 1.5em;
        height: 1.5em;
        border: none;
        padding: 0;
        line-height: normal;
        text-decoration: none;
        -webkit-mask-size: cover;
        mask-size: cover;
        cursor: pointer;
    }

    .button.speaker {
        background-color: #ffffff;
        -webkit-mask-image: url("../assets/speaker_off.svg");
        mask-image: url("../assets/speaker_off.svg");
    }

    .button.speaker.on {
        background-color: #4caf50;
        -webkit-mask-image: url("../assets/speaker_on.svg");
        mask-image: url("../assets/speaker_on.svg");
    }

</style>